﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Data;
using C1.WPF.FlexGrid;
using System.Linq;
using System.Windows.Media;

namespace GroupPanel
{
    public partial class MainWindow : Window
    {
        private readonly ObservableCollection<Product> _products=new ObservableCollection<Product>();
        private List<Product> _list;
        private List<Product> _list2;
        private bool _listSelect;
        List<string> DefineRows;
        List<Item> items;
        Dictionary<int, string> _parents;

        public MainWindow()
        {
            InitializeComponent();
            DefineRows = new List<string>();
            items = new List<Item>();
            _parents = new Dictionary<int, string>();

            // create a data source
            _list = new List<Product>();
            _list2=new List<Product>();
            for (int i = 0; i < 200; i++)
            {
                _list.Add(new Product());
            }
            for (int i = 0; i < 10; i++)
            {
                _list2.Add(new Product());
            }
            foreach (var item in _list)
            {
                _products.Add(item);
            }
            _flex.ItemsSource = _products;
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Refresh();
        }
        private void Refresh()
        {
            SaveExpandedRows();

            // get new data 
            _products.Clear();

            _listSelect = !_listSelect;

            List<Product> list;

            if (_listSelect)
                list = _list;
            else
                list = _list2;

            foreach (var item in list)
            {
                _products.Add(item);
            }
            RestoreExpandedRows();
        }
        private void SaveExpandedRows()
        {
            items.Clear();
            _parents.Clear();
            int currentLevel = 0;
            _parents.Add(0, "None");

            for (int i = 0; i <= _flex.Rows.Count - 1; i++)
            {
                GroupRow gr = _flex.Rows[i] as GroupRow;
                Item itm;
                if(gr != null)
                {
                    if(gr.Level >= currentLevel)
                    {
                        if(!_parents.ContainsKey(gr.Level + 1))
                        {
                            _parents.Add(gr.Level + 1, gr.Group.Name.ToString());
                        }

                        itm = new Item { Parent = _parents[gr.Level], Name = gr.Group.Name.ToString(), Level = gr.Level, IsCollapsed = gr.IsCollapsed };
                        items.Add(itm);

                        currentLevel = gr.Level;
                    }
                    else
                    {
                        if (_parents.ContainsKey(currentLevel))
                            _parents.Remove(currentLevel);

                        if (!_parents.ContainsKey(gr.Level + 1))
                        {
                            _parents.Add(gr.Level + 1, gr.Group.Name.ToString());
                        }
                        itm = new Item { Parent = _parents[gr.Level], Name = gr.Group.Name.ToString(), Level = gr.Level, IsCollapsed = gr.IsCollapsed };
                        items.Add(itm);

                        currentLevel = gr.Level;
                    }
                }
            }
        }
        private void RestoreExpandedRows()
        {
            _parents.Clear();
            int currentLevel = 0;
            _parents.Add(0, "None");
            Item itm;
            for (int i = 0; i <= _flex.Rows.Count - 1; i++)
            {
                GroupRow gr = _flex.Rows[i] as GroupRow;
                if (gr != null)
                {
                    if (gr.Level >= currentLevel)
                    {
                        if (!_parents.ContainsKey(gr.Level + 1))
                        {
                            _parents.Add(gr.Level + 1, gr.Group.Name.ToString());
                        }

                        itm = items.Where(e => e.Parent == _parents[gr.Level] && e.Name == gr.Group.Name.ToString() && e.Level == gr.Level).FirstOrDefault() as Item;
                        if (itm != null)
                            gr.IsCollapsed = itm.IsCollapsed;
                        currentLevel = gr.Level;
                    }
                    else
                    {
                        if (_parents.ContainsKey(currentLevel))
                            _parents.Remove(currentLevel);

                        if (!_parents.ContainsKey(gr.Level + 1))
                        {
                            _parents.Add(gr.Level + 1, gr.Group.Name.ToString());
                        }
                        itm = items.Where(e => e.Parent == _parents[gr.Level] && e.Name == gr.Group.Name.ToString() && e.Level == gr.Level).FirstOrDefault() as Item;
                        if (itm != null)
                            gr.IsCollapsed = itm.IsCollapsed;
                        currentLevel = gr.Level;
                    }
                }
            }
        }
        public ObservableCollection<Product> Products
        {
            get { return _products; }
        }
    }
}
